#include "gis.h"
G_set_color_range (min, max, colors)
    CELL min, max;
    struct Colors *colors;
{
    if (min < max)
    {
	colors->cmin = (DCELL) min;
	colors->cmax = (DCELL) max;
    }
    else
    {
	colors->cmin = (DCELL) max;
	colors->cmax = (DCELL) min;
    }
}

G_set_d_color_range (min, max, colors)
    DCELL min, max;
    struct Colors *colors;
{
    if (min < max)
    {
	colors->cmin = min;
	colors->cmax = max;
    }
    else
    {
	colors->cmin = max;
	colors->cmax = min;
    }
}

/* returns min and max category in the range or huge numbers
   if the co,lor table is defined on floating cell values and
   not on categories */

G_get_color_range(min, max, colors)
    CELL *min, *max;
    struct Colors *colors;
{
    double floor(), ceil();
    if(!colors->is_float)
    {
       *min = (CELL) floor(colors->cmin);
       *max = (CELL) ceil(colors->cmax);
    }
    else
    {
       *min = -255 * 255 * 255;
       *max = 255 * 255 * 255;
    }
}

/* returns min and max values in the range */
G_get_d_color_range(min, max, colors)
    DCELL *min, *max;
    struct Colors *colors;
{
    *min = colors->cmin;
    *max = colors->cmax;
}
