#include "gis.h"
G_make_ryg_colors (colors, min, max)
    struct Colors *colors ;
    CELL min,max;
{
    G_init_colors (colors);
    return add_ryg_colors (colors, (DCELL) min, (DCELL) max);
}

G_make_ryg_fp_colors (colors, min, max)
    struct Colors *colors ;
    DCELL min,max;
{
    G_init_colors (colors);
    return add_ryg_colors (colors, min, max);
}

G_make_red_yel_grn  (colors,min,max) /* for 3.0 compatibility */
    struct Colors *colors ;
    CELL min,max;
{
    return G_make_ryg_colors(colors,min,max);
}

G_add_ryg_colors (colors, min, max)
    struct Colors *colors ;
    CELL min,max;
{
    return add_ryg_colors (colors, (DCELL) min, (DCELL) max);
}

static
add_ryg_colors (colors, min, max)
    struct Colors *colors ;
    DCELL min,max;
{
    DCELL mid;

    if (max < min) return -1;
    if (min == 1.) min = 0.;
    if (max == -1.) max = 0.;

    mid = (min+max)/2.;

    G_add_d_raster_color_rule (&min, 255, 0, 0, &mid, 255, 255, 0, colors);
    G_add_d_raster_color_rule (&mid, 255, 255, 0, &max, 0, 255, 0, colors);
    mid = 0.;
    G_add_d_raster_color_rule (&mid, 255,255,255, &mid, 255,255,255, colors);

    return 1;
}
