#include "glob.h"

#define FPFMT "%.10lf"

void
print_range (result)
    char *result;
{
    long lmin, lmax;
    double dmin, dmax;
    char *mapset;
    char tmin[50], tmax[50];
    int ok;

    mapset = G_mapset();
    if (map_is_fp (result, mapset))
    {
	if(ok = get_dcell_range (result, mapset, &dmin, &dmax))
	{
	    sprintf (tmin, FPFMT, dmin);
	    G_trim_decimal (tmin);
	    sprintf (tmax, FPFMT, dmax);
	    G_trim_decimal (tmax);
	}
    }
    else
    {
	if(ok = get_cell_range (result, mapset, &lmin, &lmax))
	{
	    sprintf (tmin, "%ld", lmin);
	    sprintf (tmax, "%ld", lmax);
	}
    }
    if (ok)
	printf ("range: %s %s\n", tmin, tmax);
}

get_cell_range (name, mapset, lmin, lmax)
    char *name, *mapset;
    long *lmin, *lmax;
{
    struct Range range;
    CELL min, max;

    if (G_read_range (name, mapset, &range) < 0)
	return 0;
    G_get_range_min_max (&range, &min, &max);
    if (ISNULL(&min) || ISNULL(&max))
	return 0;
    *lmin = min;
    *lmax = max;
    return 1;
}

get_dcell_range (name, mapset, dmin, dmax)
    char *name, *mapset;
    double *dmin, *dmax;
{
    struct FPRange range;
    DCELL min, max;

    if (G_read_fp_range (name, mapset, &range) < 0)
	return 0;
    G_get_fp_range_min_max (&range, &min, &max);
    if (ISNULL_D(&min) || ISNULL_D(&max))
	return 0;
    *dmin = min;
    *dmax = max;
    return 1;
}
